diff -NaurdbB -xCVS lsqrms-2.0.4b.old/src/main.c lsqrms-2.0.4b/src/main.c
--- lsqrms-2.0.4b.old/src/main.c	Wed Apr 16 18:33:17 EDT 2003
+++ lsqrms-2.0.4b/src/main.c	Sun Feb 24 22:49:49 EST 2008
@@ -1,218 +1,411 @@
-#include <stdio.h>
-#include <stdlib.h>
-#include <string.h>
-#include <math.h>
-#include "provepdb.h"
+#include "lsqrms.h"
 #include "umath.h"
-
-#define RELEASE char*
-
-typedef double rotate_t[3][3];
-typedef double xlate_t[3];
-typedef struct Coord { double x, y, z; } CoordType;
-
-double MAX2(double, double);
-double MIN2(double, double);
-double FormRotMatrX(double **, double);
-double FormRotMatrY(double **, double);
-double FormRotMatrZ(double **, double);
-double AlignZ(double, double, double, double *, double *);
-int FindMaxXYZDistIdxLast(double **, int);
-int FindMaxXYDistIdxLast(double **, int);
-double TRmoveXYZstruc(double *,double **,double **, int);
-double TRvec(double *, double **, double *);
-double findCM(double **, int, double *);
-double blossom62(char, char);
-char convert321(char *);
-double distrms(CoordType *a, CoordType *b, int npts);
-int check_eq(int *, int *, int *, int *, int);
-double rotrans(double **, int, rotate_t, xlate_t);
-double bestfit(rotate_t , xlate_t , CoordType *, CoordType *, const int );
+#include "provepdb.h"
+#include "matvecalloc.h"
+#include "dynapro.h"
+#include "matvecutils.h"
 
-int     *iVector(long, long);
-int    **iMatrix(long, long, long, long);
-double  *dVector(long, long);
-char    *cVector(long, long);
-double **dMatrix(long, long, long, long);
-char   **cMatrix(long, long, long, long);
-void free_iVector(int     *, long, long);
-void free_iMatrix(int    **, long, long, long, long);
-void free_dVector(double     *, long, long);
-void free_dMatrix(double    **, long, long, long, long);
-void free_cMatrix(char      **, long, long, long, long);
-void free_cVector(char     *, long, long);
+/* cRMS = 0.44*e^(2.22*[fraction mutated residues]) -
+   Koehl and Levitt, JMB 323(3):551-562, 2002 */
+#define L_MIN 0.44		/* fraction mutated = 0 */
+#define L_MIN_SQR (L_MIN*L_MIN)
+#define L_THRESH 0.96		/* fraction mutated = 0.35 */
+#define L_THRESH_SQR (L_THRESH*L_THRESH)
+#define L_THRESH2 2.08		/* fraction mutated = 0.7 */
+#define L_THRESH2_SQR (L_THRESH2*L_THRESH2)
+#define BAD_THRESH 3.626 /* fraction mutated = 0.95 */
 
-double dyn_pr_n2(double **, int *, int *, int *, int *, int, 
-                 int, double **, double **, double **, int *, int *);
-int TrMat2Equivalences(int, int, double **, double **, int, int, int *, int *, int *);
+#define epsilon2 MAX(epsilon,1e-10)
 
-int MAXSEQ = 1000;
+static void usage(int status) {
+  fprintf(stderr,
+	  "lsqrms [-sGhao1] [-b|-B|-i|-n|-g|-p] [-l|-L|-t] source.pdb target.pdb [structal.out]\n");
+  fprintf(stderr, "Options:\n");
+  fprintf(stderr, "  -s: generate STRUCTAL-like output\n");
+  fprintf(stderr, "  -l: use LSQ_ONLY fit instead of iterated RMSD\n");
+  fprintf(stderr, "  -L: scale <= %f to 0 (%f thresh)\n", L_MIN, L_THRESH);
+  fprintf(stderr, "  -t: scale <= %f to 0 (%f thresh)\n", L_MIN, L_THRESH2);
+  fprintf(stderr, "  -G: don't use gap penalties for sequence alignment\n");
+  fprintf(stderr, "  -h: print this usage message\n");
+  fprintf(stderr, "  -1: OK if single-residue 'alignment' (also does -o)\n");
+  fprintf(stderr, "  -b: use blosum62 for initial alignment\n");
+  fprintf(stderr, "  -B: use positive-only blosum62 for initial alignment\n");
+  fprintf(stderr, "  -n: use Nussinov matrix for initial alignment\n");
+  fprintf(stderr, "  -i: use identity matrix for initial alignment\n");
+  fprintf(stderr, "  -g: use gonnet_p matrix for initial alignment\n");
+  fprintf(stderr, "  -p: use pam120_p matrix for initial alignment\n");
+  fprintf(stderr,
+	  "  -a: use altered residues (__[_0-9]) - cannot be used with -i\n");
+  fprintf(stderr, "  -o: use O, C, N as well as CA (also done by -1)\n");
+  exit(status);
+}
 
 int main(int argc, char* argv[]) {
-  double ret_val, RMS, PID, tempval;
+  double RMS, RMSold, PEQUIV, tempval, RMSsav, quality, quality_old;
   double RMSmin = 1000000;
+  double quality_max = 0;
+  double quality_sav = 0;
   int i, j;
   int rows, cols;
-  double ** s;
+  double ** ss;
   double ** SS;
+  double ** dd;
   int * iOpnPen;
-  int * iExtPen;
+  int total_OpnPen = 0;
+  double * iExtPen;
   int * jOpnPen;
-  int * jExtPen;
+  double * jExtPen;
   double ** TrRow;
   double ** TrCol;
   int iOverallMax;
   int jOverallMax;
   
-  int *iina, *iina_sav;
-  int *jinb, *jinb_sav;
-  int nbrks, nEqPairs;
+  int opt_c;
+  int opt_errflag = 0;
+  extern int optind;
+  
+  int *iina, *iina_sav, *iina_old;
+  int *jinb, *jinb_sav, *jinb_old;
+  int nbrks, nbrks_old, nEqPairs, nbrks_sav;
   
   float fp1, fp2, fp3;
   char   ** aa_que, ** aa_tar;
   double ** x_que, **x_que_original;
   double ** x_tar;
-  double ** x_que_sav;
+  double ** x_que_sav, ** x_que_old;
   double * Tcm;
   FILE *stream;
   char *char_stream, *char_stream_backup, *char_stream_head;
+  char *structal_out;
+  extern int errno;
   
-  char *s1, *s2, *s3, *s4, *a_que, *a_tar;
-  int d1, d2;
+  char *s2, *s3, *a_que, *a_tar;
+  int d2;
+  int *r_num_que, *r_num_tar;
   int StringMax = 4;
   
   rotate_t U;
   xlate_t  T;
   
-  int stay, nEqPairs_sav;
+  int stay, nEqPairs_old, nEqPairs_sav;
   int iter = 0;
+  int again = 0;
+  int again2 = 0;
+  int sav_updated = 0;
+  int increased_gap_penalties = 0;
   char aa;
   
-  double *TMPvec, *Tzero, *Tcm_que, *Tcm_tar; 
+  double *TMPvec, *Tzero, /* *Tcm_que, */ *Tcm_tar; 
   double **Rtemp, **Runity;
-  double angle_b, angle_c, angle_b_que, angle_c_que, angle_b_tar, angle_c_tar;
-  double xdir_que, ydir_que, rdir_que, xdir_tar, ydir_tar, rdir_tar;
+  double angle_b, angle_c/*, angle_b_que, angle_c_que */;
+  double angle_b_tar, angle_c_tar;
+  double xdir_que, /* ydir_que, */ rdir_que;
+  double xdir_tar, /* ydir_tar, */ rdir_tar;
   int iMaxDist;
   
   CoordType *str1, *str2;
   
-  int structal     = 0;    /* Flag to use OLD output similar to the one from STRUCTAL*/
-  int lsq          = 0;    /* Flag to use LSQ_ONLY fit instead of iterational RMSD */
+  /* Flag to use OLD output similar to the one from STRUCTAL*/
+  int structal     = 0;
+
+  /* Flag to use LSQ_ONLY fit instead of iterational RMSD */
+  int lsq          = 0;
   
   /* Modified by Julian Graham, April 2003 */
-  if (argc < 3) {
-    fprintf (stderr, "LSQRMS: need to specify .PDB filenames!  Format:\n");
-    fprintf (stderr, "  lsqrms source.pdb target.pdb\n");
-    fprintf (stderr, "Other options:\n");
-    fprintf (stderr, "  structal: generate STRUCTAL-like output\n");
-    fprintf (stderr, "  lsq: use LSQ_ONLY fit instead of interated RMSD\n");
-    return 1;   
-  }
-  if (argc == 4 && strcmp( argv[3], "structal" ) == 0 ) {
-    printf("LSQRMS was called with argument %s \n\n",argv[1]);
+
+  /* Then by Allen Smith, 2003-2007 */
+
+  int use_blosum62 = 0;
+  int use_blosum62_pos = 0;
+  int use_nussinov = 0;
+  int use_identity = 0;
+  int use_gonnet_p = 0;
+  int use_pam120_p = 0;
+  int use_gap = 1;
+  int altered = 0;
+  int use_carbonyl = 0;
+  int use_min_thresh = 0;
+  int use_min_thresh2 = 0;
+  int single_ok = 0;
+
+  while ((opt_c = getopt(argc, argv, "slLbBiGhaongtp1")) != -1) {
+    switch (opt_c) {
+    case 'a':
+      if (use_identity)
+	opt_errflag = 1;
+      else
+	altered = 1;
+      break;
+
+    case 'o':
+      use_carbonyl = 1;
+      break;
+
+    case 's':
     structal = 1;
-  }
+      break;
   
-  if (argc == 4 && strcmp( argv[3], "lsq" ) == 0 ) {
-    printf("LSQRMS was called with argument %s \n\n",argv[1]);
+    case '1':
+      single_ok = 1;
+      use_carbonyl = 1;
+      break;
+
+    case 'l':
+      if (use_min_thresh || use_min_thresh2)
+	opt_errflag = 1;
+      else
     lsq = 1;
+      break;
+
+    case 'L':
+      if (lsq || use_min_thresh2)
+	opt_errflag = 1;
+      else
+	use_min_thresh = 1;
+      break;
+
+    case 't':
+      if (lsq || use_min_thresh)
+	opt_errflag = 1;
+      else
+	use_min_thresh2 = 1;
+      break;
+
+    case 'p':
+      if (use_identity || use_nussinov || use_gonnet_p || use_blosum62 ||
+	  use_blosum62_pos)
+	opt_errflag = 1;
+      else
+	use_pam120_p = 1;
+      break;
+
+    case 'b':
+      if (use_identity || use_nussinov || use_gonnet_p || use_pam120_p)
+	opt_errflag = 1;
+      else
+	use_blosum62 = 1;
+      break;
+
+    case 'B':
+      if (use_identity || use_nussinov || use_gonnet_p || use_pam120_p)
+	opt_errflag = 1;
+      else
+	use_blosum62_pos = 1;
+      break;
+
+    case 'i':
+      if (use_blosum62 || altered || use_nussinov || use_pam120_p ||
+	  use_blosum62_pos || use_gonnet_p)
+	opt_errflag = 1;
+      else
+	use_identity = 1;
+      break;
+
+    case 'n':
+      if (use_blosum62 || use_identity || use_blosum62_pos ||
+	  use_gonnet_p || use_pam120_p)
+	opt_errflag = 1;
+      else
+	use_nussinov = 1;
+      break;
+
+    case 'g':
+      if (use_blosum62 || use_identity || use_blosum62_pos ||
+	  use_nussinov || use_pam120_p)
+	opt_errflag = 1;
+      else
+	use_gonnet_p = 1;
+      break;
+
+    case 'G':
+      use_gap = 0;
+      break;
+
+    case 'h':
+      usage(0);
+      /* NOTREACHED */
+      break;
+
+    case '?':
+      opt_errflag = 1;
+      break;
   }
-  if (argc == 5 && (strcmp( argv[3], "structal" ) == 0) && 
-      strcmp( argv[4], "lsq" ) == 0 ) {
-    printf("LSQRMS was called with arguments %s %s \n\n",argv[3],argv[4]);
-    lsq = 1;
-    structal = 1;
   }
-  if (argc == 5 && (strcmp( argv[4], "structal" ) == 0) && 
-      strcmp( argv[3], "lsq" ) == 0 ) {
-    printf("LSQRMS was called with arguments %s %s \n\n",argv[1],argv[2]);
-    lsq = 1;
-    structal = 1;
+
+  if (opt_errflag)
+    usage(2);
+
+  if ((argc - optind) < 1) {
+    fprintf (stderr, "LSQRMS: need to specify (2) .PDB filenames!\n");
+    usage(2);
   }
   
-  printf("Program LSQRMS. Version 2.02\n");
-  stay = 1; nEqPairs_sav = -1; nEqPairs = -1;
+  printf("Program LSQRMS. Version 2.02-Allen-10/26/2005\n");
+  if (structal) {
+    if ((argc - optind) < 2)
+      structal_out = strdup("structal.out");
+    else
+      structal_out = strdup(argv[optind+2]);
+    printf("Using Structal output format (output to %s)\n", structal_out);
+  }
   
-  s1 = cVector(1,StringMax);
+  if (lsq)
+    printf("Doing LSQ_ONLY fit instead of iterated RMSD\n");
+  else if (use_min_thresh)
+    printf("Scaling <= %f to 0 (%f threshold)\n", L_MIN, L_THRESH);
+  else if (use_min_thresh2)
+    printf("Scaling <= %f to 0 (%f threshold)\n", L_MIN, L_THRESH2);
+
+  if (altered)
+    printf("Using altered residues for site/whatever alignment\n");
+  if (use_carbonyl)
+    printf("Using O, C, N as well as CA\n");
+
+  if (use_blosum62_pos)
+    printf("Using positive-only blosum62 for initial alignment\n");
+  else if (use_blosum62)
+    printf("Using blosum62 for initial alignment\n");
+  else if (use_nussinov)
+    printf("Using Nussinov (Naor et al 1996) matrix for initial alignment\n");
+  else if (use_identity)
+    printf("Using identity matrix for initial alignment\n");
+  else if (use_gonnet_p)
+    printf("Using gonnet_p matrix for initial alignment\n");
+  else if (use_pam120_p)
+    printf("Using pam120_p matrix for initial alignment\n");
+
+  if (use_gap)
+    printf("Using gap penalties for initial alignment\n");
+  else
+    printf("Not using gap penalties for initial alignment\n");
+  fflush(NULL);
+
+  stay = 1; nEqPairs_sav = -1; nEqPairs = -1; nEqPairs_old = -1;
+  
+  /* s1 = cVector(1,StringMax); */
   s2 = cVector(1,StringMax);
   s3 = cVector(1,3);
-  s4 = cVector(1,StringMax);
+  /* s4 = cVector(1,StringMax); */
   
   /* ATOM      2  CA  ASP H  19      30.313   5.590  12.619  */
-  char_stream = provepdb (argv[1]);
+  /* ATOM      3  O   ASP H  19      30.313   5.590  12.619  */
+  char_stream = provepdb(argv[optind],altered,use_carbonyl);
   if (char_stream == NULL) {
-    fprintf (stderr, "Couldn't open file \'%s\'\n", argv[1]);
+    fprintf (stderr, "Couldn't open file \'%s\'\n", argv[optind]);
+    return 1; 
+  } else {
+    char_stream_backup = strdup(char_stream);
+    if (char_stream_backup == NULL) {
+      fprintf(stderr, "Out of memory for strdup of char_stream for \'%s\'\n",
+	      argv[optind]);
     return 1; 
   }
-  else {
-    char_stream_backup = strdup (char_stream);
     char_stream_head = char_stream;
     i=0;
     while (1) {
-      (void) sscanf (char_stream, "%4c %d %2c %3c %c %d %f %f %f\n", 
-		      s1, &d1, s2, s3, s4, &d2,
-		      &fp1, &fp2, &fp3);
-      char *new_pointer = strstr (char_stream + 4, "ATOM");      
-      aa = convert321( s3 );
+      char *new_pointer;
+
+      (void) sscanf(char_stream,
+		    "ATOM %*d %2c %3[^ ] %d %f %f %f\n", 
+		    s2, s3, &d2, &fp1, &fp2, &fp3);
+      new_pointer = strstr(char_stream + 4, "ATOM");
       i++;
-      if (new_pointer == NULL) break;
+      if (new_pointer == NULL)
+	break;
       else {
 	char_stream = (char *) (new_pointer);
 	continue;
       }      
-    } 
+    } /* while (1) */
   }
   rows = i;
 
-  free (char_stream_head);
+  free(char_stream_head);
   char_stream = char_stream_backup;
   char_stream_head = char_stream;
 
   x_que     = dMatrix(1,3,0,rows-1);
   x_que_sav = dMatrix(1,3,0,rows-1);
+  x_que_old = dMatrix(1,3,0,rows-1);
   x_que_original = dMatrix(1,3,0,rows-1);
   a_que     = cVector(0,rows-1);
   aa_que    = cMatrix(0,rows-1,0,2);
+  r_num_que = iVector(0,rows-1);
 
-  for(i = 0; i < rows; i++) {
+  for (i = 0; i < rows; i++) {
     char *new_pointer = strstr (char_stream + 4, "ATOM");
-    (void) sscanf (char_stream, "%4c %d %2c %3c %c %d %f %f %f\n", 
-		   s1, &d1, s2, s3, s4, &d2, &fp1, &fp2, &fp3);
+
+    if (sscanf(char_stream,
+	       "ATOM %*d %2c %3[^ ] %d %f %f %f\n", 
+	       s2, s3, &d2, &fp1, &fp2, &fp3) == 6) {
     char_stream = (char *) (new_pointer);
-    aa = convert321( s3 );
+      aa = convert321(s3,1,altered);
+      if (use_carbonyl && isalpha(aa)) {
+	if (islower(aa))
+	  aa = _toupper(aa);
+	if (s2[0] == 'C') {
+	  if (s2[1] != 'A')
+	    aa = tohigh(_tolower(aa));
+	} else if (s2[0] == 'O')
+	  aa = _tolower(aa);
+	else
+	  aa = tohigh(aa);
+      }
     a_que[i] = aa;
+      r_num_que[i] = d2;
     aa_que[i][0] = s3[0];
     aa_que[i][1] = s3[1];
     aa_que[i][2] = s3[2];
-    x_que[1][i]=fp1; x_que_sav[1][i]=fp1; x_que_original[1][i]=fp1;
-    x_que[2][i]=fp2; x_que_sav[2][i]=fp2; x_que_original[2][i]=fp2;
-    x_que[3][i]=fp3; x_que_sav[3][i]=fp3; x_que_original[3][i]=fp3;
+      
+      x_que[1][i] = fp1;
+      x_que_sav[1][i] = fp1;
+      x_que_old[1][i] = fp1;
+      x_que_original[1][i] = fp1;
+      
+      x_que[2][i] = fp2;
+      x_que_sav[2][i] = fp2;
+      x_que_old[2][i] = fp2;
+      x_que_original[2][i] = fp2;
+      
+      x_que[3][i] = fp3;
+      x_que_sav[3][i] = fp3;
+      x_que_old[3][i] = fp3;
+      x_que_original[3][i] = fp3;
+    } else {
+      fprintf(stderr, "Unable to convert %s\n", char_stream);
+      return 1;
+    }
   } /* for(i) */
   
-  free (char_stream_head);
-  char_stream = provepdb (argv[2]);
+  free(char_stream_head);
+  char_stream = provepdb(argv[optind+1],altered,use_carbonyl);
   if (char_stream == NULL) {
-    fprintf (stderr, "Couldn't open file \'%s\'\n", argv[2]);
+    fprintf (stderr, "Couldn't open file \'%s\'\n", argv[optind+1]);
     return 1; 
-  }
-  else {
+  } else {
     char_stream_backup = strdup (char_stream);
+    if (char_stream_backup == NULL) {
+      fprintf(stderr, "Out of memory for strdup of char_stream for \'%s\'\n",
+	      argv[optind+1]);
+      return 1;
+    }
     char_stream_head = char_stream;
     i=0;
     while (1) {
-      (void) sscanf (char_stream, "%4c %d %2c %3c %c %d %f %f %f\n",
-		      s1, &d1, s2, s3, s4, &d2,
-		      &fp1, &fp2, &fp3);
-      char *new_pointer = strstr (char_stream + 4, "ATOM");
-      aa = convert321( s3 );
+      char *new_pointer;
+
+      (void) sscanf(char_stream,
+		    "ATOM %*d %2c %3[^ ] %d %f %f %f\n", 
+		    s2, s3, &d2, &fp1, &fp2, &fp3);
+      new_pointer = strstr (char_stream + 4, "ATOM");
       i++;
-      if (new_pointer == NULL) break;
+      if (new_pointer == NULL)
+	break;
       else {
 	char_stream = (char *) (new_pointer);
 	continue;
       }
-    }
-      /* while */
+    } /* while (1) */
   }
   cols = i;
   
@@ -224,142 +417,292 @@
   x_tar     = dMatrix(1,3,0,cols-1);
   a_tar     = cVector(0,cols-1);
   aa_tar    = cMatrix(0,cols-1,0,2);
+  r_num_tar = iVector(0,cols-1);
   
   for (i = 0; i < cols; i++) {
     char *new_pointer = strstr (char_stream + 4, "ATOM");
-    (void) sscanf (char_stream, "%4c %d %2c %3c %c %d %f %f %f\n", 
-		s1, &d1, s2, s3, s4, &d2,
-		   &fp1, &fp2, &fp3);
+
+    if (sscanf(char_stream,
+	       "ATOM %*d %2c %3[^ ] %d %f %f %f\n", 
+	       s2, s3, &d2, &fp1, &fp2, &fp3) == 6) {
     char_stream = (char *) (new_pointer);
-    aa = convert321( s3 );
+      aa = convert321(s3,1,altered);
+      if (use_carbonyl && isalpha(aa)) {
+	if (islower(aa))
+	  aa = _toupper(aa);
+	if (s2[0] == 'C') {
+	  if (s2[1] != 'A')
+	    aa = tohigh(_tolower(aa));
+	} else if (s2[0] == 'O')
+	  aa = _tolower(aa);
+	else
+	  aa = tohigh(aa);
+      }
     a_tar[i] = aa;
+      r_num_tar[i] = d2;
     aa_tar[i][0] = s3[0];
     aa_tar[i][1] = s3[1];
     aa_tar[i][2] = s3[2];
-    x_tar[1][i]=fp1; 
-    x_tar[2][i]=fp2; 
-    x_tar[3][i]=fp3; 
-  } /* for(i) */
-  free (char_stream_head);
+      x_tar[1][i] = fp1; 
+      x_tar[2][i] = fp2; 
+      x_tar[3][i] = fp3;
+    } else {
+      fprintf(stderr, "Unable (2) to interpret %s\n",char_stream);
+      return 1;
+    }
+  } /* for (i < cols) */
+
+  free(char_stream_head);
   /* ATOM     10  CA  GLU H  20      30.998   8.719  10.360  */
   
   iOverallMax = -1;
   jOverallMax = -1;
   
-  s       = dMatrix(0,rows-1,0,cols-1);
-  SS      = dMatrix(0,rows-1,0,cols-1);
-  TrRow   = dMatrix(0,rows-1,0,cols-1);
-  TrCol   = dMatrix(0,rows-1,0,cols-1);
+  ss      = dMatrix(0,rows+1,0,cols+1);
+  SS      = dMatrix(0,rows+1,0,cols+1);
+  dd      = dMatrix(0,rows+1,0,cols+1);
+  TrRow   = dMatrix(0,rows,0,cols);
+  TrCol   = dMatrix(0,rows,0,cols);
   iOpnPen = iVector(0,rows-1);
-  iExtPen = iVector(0,rows-1);
+  iExtPen = dVector(0,rows-1);
   jOpnPen = iVector(0,cols-1);
-  jExtPen = iVector(0,cols-1);
+  jExtPen = dVector(0,cols-1);
   
   iina_sav = iVector(0,MAXSEQ);
   jinb_sav = iVector(0,MAXSEQ);
   
+  
   /* FIRST OF ALL, MOVE que->CM(tar); NEXT, align PRINCIPAL AXES OF INERTIA: */
   
   Tcm     = dVector(1,3); 
-  Tcm_que = dVector(1,3); 
+  /* Tcm_que = dVector(1,3); */
   Tcm_tar = dVector(1,3); 
  Tzero   = dVector(1,3); 
  TMPvec  = dVector(1,3); 
  Rtemp   = dMatrix(1,3,1,3);
  Runity  = dMatrix(1,3,1,3);
- Rtemp[1][1]  = 1.0; Rtemp[1][2]  = 0.0; Rtemp[1][3]  = 0.0;
- Rtemp[2][1]  = 0.0; Rtemp[2][2]  = 1.0; Rtemp[2][3]  = 0.0;
- Rtemp[3][1]  = 0.0; Rtemp[3][2]  = 0.0; Rtemp[3][3]  = 1.0;
- Runity[1][1] = 1.0; Runity[1][2] = 0.0; Runity[1][3] = 0.0;
- Runity[2][1] = 0.0; Runity[2][2] = 1.0; Runity[2][3] = 0.0;
- Runity[3][1] = 0.0; Runity[3][2] = 0.0; Runity[3][3] = 1.0;
- TMPvec[1]  = 2; TMPvec[2]  = 3;   TMPvec[3]  = 4;
- Tzero[1]   = 00.e0; Tzero[2] = 0.0e0; Tzero[3]   = 0.0e0;
  
- ret_val = findCM(x_tar,cols,Tcm);
+  Rtemp[1][1]  = 1.0;
+  Rtemp[1][2]  = 0.0;
+  Rtemp[1][3]  = 0.0;
 
- Tcm_tar[1] = Tcm[1];  Tcm_tar[2] = Tcm[2];  Tcm_tar[3] = Tcm[3]; /* saved inv translation */
- Tcm[1] = -Tcm[1];  Tcm[2] = -Tcm[2];  Tcm[3] = -Tcm[3];
+  Rtemp[2][1]  = 0.0;
+  Rtemp[2][2]  = 1.0;
+  Rtemp[2][3]  = 0.0;
 
- ret_val = TRmoveXYZstruc(Tcm,Runity,x_tar,cols);
+  Rtemp[3][1]  = 0.0;
+  Rtemp[3][2]  = 0.0;
+  Rtemp[3][3]  = 1.0;
 
- ret_val = findCM(x_tar,cols,Tcm);
+  Runity[1][1] = 1.0;
+  Runity[1][2] = 0.0;
+  Runity[1][3] = 0.0;
+
+  Runity[2][1] = 0.0;
+  Runity[2][2] = 1.0;
+  Runity[2][3] = 0.0;
+
+  Runity[3][1] = 0.0;
+  Runity[3][2] = 0.0;
+  Runity[3][3] = 1.0;
+
+  TMPvec[1] = 2;
+  TMPvec[2] = 3;
+  TMPvec[3] = 4;
+
+  Tzero[1] = 00.e0;
+  Tzero[2] = 0.0e0;
+  Tzero[3] = 0.0e0;
+ 
+  (void)findCM(x_tar,cols,Tcm);
+
+  /* saved inv translation */
+  Tcm_tar[1] = Tcm[1];
+  Tcm_tar[2] = Tcm[2];
+  Tcm_tar[3] = Tcm[3];
+
+  Tcm[1] = -Tcm[1];
+  Tcm[2] = -Tcm[2];
+  Tcm[3] = -Tcm[3];
+
+  (void)TRmoveXYZstruc(Tcm,Runity,x_tar,cols);
+  
+  (void)findCM(x_tar,cols,Tcm);
 
  iMaxDist = FindMaxXYZDistIdxLast(x_tar,cols);
- ret_val  = AlignZ(x_tar[1][iMaxDist],x_tar[2][iMaxDist],x_tar[3][iMaxDist],&angle_b,&angle_c);
- angle_b_tar = -angle_b; angle_c_tar = -angle_c; /* saved inv rotation */
+  (void)AlignZ(x_tar[1][iMaxDist],x_tar[2][iMaxDist],x_tar[3][iMaxDist],
+	       &angle_b,&angle_c);
+  /* saved inv rotation */
+  angle_b_tar = -angle_b;
+  angle_c_tar = -angle_c;
 
- ret_val = FormRotMatrY(Rtemp,angle_b);
- ret_val = TRmoveXYZstruc(Tzero,Rtemp,x_tar,cols);
- ret_val = FormRotMatrX(Rtemp,angle_c);
- ret_val = TRmoveXYZstruc(Tzero,Rtemp,x_tar,cols);
+  (void)FormRotMatrY(Rtemp,angle_b);
+  (void)TRmoveXYZstruc(Tzero,Rtemp,x_tar,cols);
+  (void)FormRotMatrX(Rtemp,angle_c);
+  (void)TRmoveXYZstruc(Tzero,Rtemp,x_tar,cols);
 
  iMaxDist = FindMaxXYDistIdxLast(x_tar,cols);
 
  rdir_tar = sqrt( SQR(x_tar[1][iMaxDist]) + SQR(x_tar[2][iMaxDist]) );
- xdir_tar = x_tar[1][iMaxDist]/rdir_tar; /* <- need it to determine XY-plane rotation */
- ydir_tar = x_tar[2][iMaxDist]/rdir_tar; /* <- need it to determine XY-plane rotation */
+  /* xdir_tar: needed to determine XY-plane rotation */
+  xdir_tar = x_tar[1][iMaxDist]/rdir_tar;
+  /* ydir_tar = x_tar[2][iMaxDist]/rdir_tar; */
 
-/* Do the same for the QUERY: */
- ret_val = findCM(x_que,rows,Tcm);
- Tcm_que[1] = Tcm[1];  Tcm_que[2] = Tcm[2];  Tcm_que[3] = Tcm[3]; /* saved inv translation */
+  /* Do the same for the QUERY: */
+  (void)findCM(x_que,rows,Tcm);
+  /* saved inv translation */
+  /* Tcm_que[1] = Tcm[1];
+     Tcm_que[2] = Tcm[2];
+     Tcm_que[3] = Tcm[3]; */
 
- Tcm[1] = -Tcm[1];  Tcm[2] = -Tcm[2];  Tcm[3] = -Tcm[3];
+  Tcm[1] = -Tcm[1];
+  Tcm[2] = -Tcm[2];
+  Tcm[3] = -Tcm[3];
 
- ret_val = TRmoveXYZstruc(Tcm,Runity,x_que,rows);
+  (void)TRmoveXYZstruc(Tcm,Runity,x_que,rows);
+  printf("Moving query: %.10f %.10f %.10f\n", Tcm[1], Tcm[2], Tcm[3]);
 
- ret_val = findCM(x_que,rows,Tcm);
+  (void)findCM(x_que,rows,Tcm);
 
  iMaxDist = FindMaxXYZDistIdxLast(x_que,rows);
- ret_val  = AlignZ(x_que[1][iMaxDist],x_que[2][iMaxDist],x_que[3][iMaxDist],&angle_b,&angle_c);
- angle_b_que = -angle_b; angle_c_que = -angle_c; /* saved inv rotation */
+  (void)AlignZ(x_que[1][iMaxDist],x_que[2][iMaxDist],x_que[3][iMaxDist],
+	       &angle_b,&angle_c);
+  /* saved inv rotation - not needed (Allen) */
+  /* angle_b_que = -angle_b; angle_c_que = -angle_c; */
 
- ret_val = FormRotMatrY(Rtemp,angle_b);
- ret_val = TRmoveXYZstruc(Tzero,Rtemp,x_que,rows);
- ret_val = FormRotMatrX(Rtemp,angle_c);
- ret_val = TRmoveXYZstruc(Tzero,Rtemp,x_que,rows);
+  (void)FormRotMatrY(Rtemp,angle_b);
+  (void)TRmoveXYZstruc(Tzero,Rtemp,x_que,rows);
+  printf("Rotating query: y-angle %.10f; %.10f %.1f %.10f; %.1f %.1f %.1f; %.10f %.1f %.10f\n",
+	 angle_b,
+	 Rtemp[1][1],Rtemp[1][2],Rtemp[1][3],
+	 Rtemp[2][1],Rtemp[2][2],Rtemp[2][3],
+	 Rtemp[3][1],Rtemp[3][2],Rtemp[3][3]);
+  (void)FormRotMatrX(Rtemp,angle_c);
+  (void)TRmoveXYZstruc(Tzero,Rtemp,x_que,rows);
+  printf("Rotating query: x-angle %.10f; %.1f %.1f %.1f; %.1f %.10f %.10f; %.1f %.10f %.10f\n",
+	 angle_c,
+	 Rtemp[1][1],Rtemp[1][2],Rtemp[1][3],
+	 Rtemp[2][1],Rtemp[2][2],Rtemp[2][3],
+	 Rtemp[3][1],Rtemp[3][2],Rtemp[3][3]);
 
  iMaxDist = FindMaxXYDistIdxLast(x_que,rows);
 
  rdir_que = sqrt( SQR(x_que[1][iMaxDist]) + SQR(x_que[2][iMaxDist]) );
- xdir_que = x_que[1][iMaxDist]/rdir_que; /* <- need it to determine XY-plane rotation */
- ydir_que = x_que[2][iMaxDist]/rdir_que; /* <- need it to determine XY-plane rotation */
+  /* xdir_que: needed to determine XY-plane rotation */
+  xdir_que = x_que[1][iMaxDist]/rdir_que;
+  /* ydir_que = x_que[2][iMaxDist]/rdir_que; */
 
  angle_b = acos(xdir_tar);
  angle_c = acos(xdir_que);
 
- ret_val = FormRotMatrZ(Rtemp,angle_c-angle_b);
- ret_val = TRmoveXYZstruc(Tzero,Rtemp,x_que,rows);
+  (void)FormRotMatrZ(Rtemp,angle_c-angle_b);
+  (void)TRmoveXYZstruc(Tzero,Rtemp,x_que,rows);
+  printf("Rotating query: z-angle %.10f; %.10f %.10f %.1f; %.10f %.10f %.1f; %.1f %.1f %.1f\n",
+	 (angle_c-angle_b),
+	 Rtemp[1][1],Rtemp[1][2],Rtemp[1][3],
+	 Rtemp[2][1],Rtemp[2][2],Rtemp[2][3],
+	 Rtemp[3][1],Rtemp[3][2],Rtemp[3][3]);
 
-/* CHECK COORDINATES: */
-/*
- stream = fopen( "coordchk.txt", "w" );
- if( stream == NULL )
-   printf( "Couldn't open file coordchk.txt\n" );
- else   {
-   fprintf( stream, "Query: \n");
-   for(i=0;i<rows;i++) {
-	  fprintf( stream, "%12.3f %8.3f %8.3f\n", x_que[1][i], x_que[2][i], x_que[3][i]);
+  /* CHECK COORDINATES: */
+/*   stream = fopen( "coordchk.txt", "w" ); */
+/*   if( stream == NULL ) */
+/*     printf( "Couldn't open file coordchk.txt\n" ); */
+/*   else { */
+/*     fprintf( stream, "Query: \n"); */
+/*     for (i=0;i<rows;i++) { */
+/*       fprintf( stream, "%12.3f %8.3f %8.3f\n", */
+/* 	       x_que[1][i], x_que[2][i], x_que[3][i]); */
+/*     } */
+/*     fprintf( stream, "Target: \n"); */
+/*     for (i=0;i<cols;i++) { */
+/*       fprintf( stream, "%12.3f %8.3f %8.3f\n", */
+/* 	       x_tar[1][i], x_tar[2][i], x_tar[3][i]); */
+/*     } */
+/*     fclose( stream ); */
+/*   } */
+ 
+  /* INITIAL STARTING POINT: SEQUENCE ALIGNMENT.
+     Decide if needed (based on PID) */
+  iina = iVector(0,MAXSEQ);
+  jinb = iVector(0,MAXSEQ);
+  iina_old = iVector(0,MAXSEQ);
+  jinb_old = iVector(0,MAXSEQ);
+  for (i=0; i<=MAXSEQ; i++) {
+    iina[i] = -1;
+    jinb[i] = -1;
 	}
-   fprintf( stream, "Target: \n");
-   for(i=0;i<cols;i++) {
-	  fprintf( stream, "%12.3f %8.3f %8.3f\n", x_tar[1][i], x_tar[2][i], x_tar[3][i]);
+  for (j=0; j<=(cols-1); j++) {
+    if (use_gap && (j < (cols-1))) {
+/* values from J. Mol. Biol. (1995) 249, 816-831:
+   An Assessment of Amino Acid Exchange Matrices in
+   Aligning Protein Sequences: The Twilight Zone
+   Revisited, by Gerhard Vogt, Thure Etzold and
+   Patrick Argos */
+      /* NOTE: values use Opn + ((len-1)*Ext) formula */
+      if (use_nussinov) { /* estimated from pam60_p values */
+	jOpnPen[j] = 14;
+	jExtPen[j] = 1.5;
+      } else if (use_gonnet_p) {
+	jOpnPen[j] = 6;
+	jExtPen[j] = 0.8;
+      } else if (use_blosum62_pos) {
+	jOpnPen[j] = 20;
+	jExtPen[j] = 1.2;
+      } else if (use_blosum62) {
+	jOpnPen[j] = 15;
+	jExtPen[j] = 1.8;
+      } else if (use_identity) {
+	jOpnPen[j] = 1;
+	jExtPen[j] = 0.07;
+      } else if (use_pam120_p) {
+	jOpnPen[j] = 12.5;
+	jExtPen[j] = 1;
+      } else {
+	jOpnPen[j] = 15;
+	jExtPen[j] = 0.92;
    }
-   fclose( stream );
+      if ((cols > rows) && (j >= (rows-1)))
+	jOpnPen[j] = 0;
+      if ((toascii(a_tar[j]) == 'X') || (toascii(a_tar[j]) == 'x'))
+	jExtPen[j] = 0.0;
+    } else {
+      jOpnPen[j] = 0;
+      jExtPen[j] = 0.0;
  }
-*/
-/* INITIAL STARTING POINT: SEQUENCE ALIGNMENT. Decide if needed (based on PID) */
- iina = iVector(0,MAXSEQ);
- jinb = iVector(0,MAXSEQ);
- for(i=0;i<=MAXSEQ;i++) {
-   iina[i] = -1; jinb[i] = -1;
  }
- for(j=0;j<=cols-1;j++) {
-     jOpnPen[j] = 0; jExtPen[j] = 0;
+  for (i=0; i<=(rows-1); i++) {
+    if (use_gap && (i < (rows-1))) {
+      if (use_nussinov) { /* estimated from pam60_p values */
+	iOpnPen[i] = 14;
+	iExtPen[i] = 1.5;
+      } else if (use_gonnet_p) {
+	iOpnPen[i] = 6;
+	iExtPen[i] = 0.8;
+      } else if (use_blosum62_pos) {
+	iOpnPen[i] = 20;
+	iExtPen[i] = 1.2;
+      } else if (use_blosum62) {
+	iOpnPen[i] = 15;
+	iExtPen[i] = 1.8;
+      } else if (use_identity) {
+	iOpnPen[i] = 1;
+	iExtPen[i] = 0.07;
+      } else if (use_pam120_p) {
+	iOpnPen[i] = 12.5;
+	iExtPen[i] = 1;
+      } else {
+	iOpnPen[i] = 15;
+	iExtPen[i] = 0.92;
  }
- for(i=0;i<=rows-1;i++) {
-	 iOpnPen[i] = 0;  iExtPen[i] = 0;
-	for(j=0;j<=cols-1;j++) {       
+      if ((rows > cols) && (i >= (cols-1)))
+	iOpnPen[i] = 0;
+      if ((toascii(a_que[i]) == 'X') || (toascii(a_que[i]) == 'x'))
+	iExtPen[i] = 0.0;
+    } else {
+      iOpnPen[i] = 0;
+      iExtPen[i] = 0.0;
+    }
+    for (j=0; j<=(cols-1); j++) {       
 		SS[i][j]    = 0.0;
         TrRow[i][j] = 0.0;
 		TrCol[i][j] = 0.0;
